## boot-floppies 2.1.12

=== Makefile ===
#!/usr/bin/make -f

# Edit the variables below this line
LINGUA=C
export LINGUA

# Only define this if the boot disks are not creaed by the package maintainer
# MAINTAINER=Martin Schulze <joey@debian.org>
# export MAINTAINER

debianversion=2.1

# Customize this to refer to the path of the Debian archive.
# It has to be an absolute PATH or else the basedisks.sh script will fail.
ftp_archive=/archive/debian

architecture=$(shell dpkg --print-architecture)
export architecture

ifeq ($(architecture), powerpc)
  archive=$(ftp_archive)/dists/potato/main/binary-$(architecture)
else
  archive=$(ftp_archive)/dists/slink/main/binary-$(architecture)
endif
tools_dir=$(ftp_archive)/tools
kernel_dir=$(ftp_archive)/project/other_kernels
# incoming:=$(ftp_archive)/Incoming
incoming:=../../Incoming
local=$(ftp_archive)/local/binary-$(architecture)

# where to look for .deb files (local updates, archive base & admin dirs)
pathcmd = ls -1ft updates/P $(local)/P $(archive)/base/P $(archive)/admin/P 2>/dev/null | head -1

-include Makefile.config

kbd_package:=$(shell $(pathcmd:P=kbd-data_0.96*.deb))

#---------------------------------------------------------------------------

# IF your language uses the Latin-2 charset, add its two letter code below.
LATIN2:=cs hr pl sk
# IF your language uses the Latin-3 charset, add its two letter code below.
LATIN3:=eo
ifneq ($(strip $(findstring $(LINGUA),$(LATIN2))),)
        export FONT=iso02g.psf
endif
ifneq ($(strip $(findstring $(LINGUA),$(LATIN3))),)
        export FONT=iso03g.psf
endif

ifeq ($(FONT), iso02g.psf)
	export SFONT=iso02.f16
endif
ifeq ($(FONT), iso03g.psf)
	export SFONT=iso03.f16
endif

# [ED] avoid direct compilation of C programs from the utilities subdir
# (see the root.bin dependencies).  BTW utils target do the right job.
.SUFFIXES:

all::	build

#---------------------------------------------------------------------------
# Kernel
#---------------------------------------------------------------------------
# kver    = main kernel for bootdisks
# altkver = alternate kernel for more bootdisks
kver:=2.0.35
ifeq ($(architecture), powerpc)
  kver:=2.2.3
  kbd_package:=$(shell $(pathcmd:P=kbd-data_0.97*.deb))
else
  ifeq ($(architecture), i386)
    kver:=2.0.38
  else
    ifeq ($(architecture), sparc)
      altkver:=2.2.1
    endif
  endif
endif

# find the newest kernel image of each type
kernel:=$(shell $(pathcmd:P=kernel-image-$(kver)_*.deb))
altkernel:=$(shell $(pathcmd:P=kernel-image-$(altkver)_*.deb))

# sanity fallback for kernel
ifeq ($(strip $(kernel)),)
kernel:=kernel-image-$(kver)_$(kver)-1.deb
endif

pcmcia_package:=$(shell $(pathcmd:P=pcmcia-modules-$(kver)_*.deb))

# alpha part
kernelalpha:=../kernel-image-2.0.35-
alpha_arches:= avanti xl xlt cabriolet eb66 eb66p eb64p eb164 pc164 \
      lx164 sx164 jensen noname takara mikasa noritake alcor \
      miata miata-s sable sable-g book1 ruffian 
alpha_rescue_targets := $(alpha_arches:%=resc1440_%.bin)
alpha_drivers_targets := $(alpha_arches:%=drv1440_%.bin)

#### m68k part
kernelatari=$(archive)/base/kernel-image-2.0.36-atari_2.0.36-1.deb
kernelamiga=$(archive)/base/kernel-image-2.0.36-amiga_2.0.36-1.deb
kernelmac=$(archive)/updates/kernel-image-2.0.36-mac_2.0.36-2.deb
kernelbvme6000=$(archive)/base/kernel-image-2.0.36-bvme6000_2.0.36-1.deb
kernelmvme162=$(archive)/base/kernel-image-2.0.36-mvme162_2.0.36-1.deb
kernelmvme167=$(archive)/base/kernel-image-2.0.36-mvme167_2.0.36-1.deb
tftplilo=$(archive)/updates/tftplilo_1.0.0-1_all.deb

#### powerpc part
kernelapus:=$(shell $(pathcmd:P=kernel-image-$(kver)-apus*.deb))
kernelchrp:=$(shell $(pathcmd:P=kernel-image-$(kver)-chrp*.deb))
kernelmbx:=$(shell  $(pathcmd:P=kernel-image-$(kver)-mbx*.deb))
kernelpmac:=$(shell $(pathcmd:P=kernel-image-$(kver)-pmac*.deb))
kernelprep:=$(shell $(pathcmd:P=kernel-image-$(kver)-prep*.deb))

#### sparc part
# Sparc dist contains 3 kernels:
#  2.0.35 for sun4[cdm] (microsparc, supersparc, hypersparc, ...)
#  2.2.1  for sun4[cdm]
#  2.2.1  for sun4u (ultrasparc)
ifeq ($(architecture), sparc)
  altkernel64:=$(shell $(pathcmd:P=kernel-image-$(altkver)-sun4u_*.deb))
endif

#### Laptop part 
kerneltecra:=$(shell $(pathcmd:P=kernel-image-$(kver)-scsimod_*.deb))

#---------------------------------------------------------------------------
# Consistency checks
#---------------------------------------------------------------------------
check: localfiles check_mirror check_loop check_minix check_kernel
	@echo "check successful"

# Use this to check if your kernel has support for the minix filesystem
check_minix:
	grep minix /proc/filesystems 2>&1 >/dev/null || \
		test -f /lib/modules/`uname -r`/fs/minix.o || \
		( echo minix filesystem support needed; exit 1 )

# Use this to check if your kernel has support for the loop device
check_loop:
	grep loop /proc/devices 2>&1 >/dev/null || \
		test -f /lib/modules/`uname -r`/block/loop.o || \
		( echo loop device support needed ; exit 1 )

# Use this to check if your local mirror has all the required packages
check_mirror: check_mirror.sh
	./check_mirror.sh $(archive)

# Use this to see if you have the proper kernels available
check_kernel:
ifeq ($(architecture), i386)
	[ -f "$(kernel)" ] || \
		( echo standard kernel is not available ; exit 1 )
	[ -f "$(pcmcia_package)" ] || \
		( echo PCMCIA modules are not available ; exit 1 )
	[ -f "$(kerneltecra)" ] || \
		( echo tecra kernel is not available ; exit 1 )
else
  ifeq ($(architecture), m68k)
	[ -f "$(kernelatari)" ] || \
		( echo atari kernel is not available ; exit 1 )
	[ -f "$(kernelamiga)" ] || \
		( echo amiga kernel is not available ; exit 1 )
	[ -f "$(kernelmac)" ] || \
		( echo mac kernel is not available ; exit 1 )
	[ -f "$(kernelbvme6000)" ] || \
		( echo bvme6000 kernel is not available ; exit 1 )
	[ -f "$(kernelmvme162)" ] || \
		( echo mvme162 kernel is not available ; exit 1 )
	[ -f "$(kernelmvme167)" ] || \
		( echo mvme167 kernel is not available ; exit 1 )
else
  ifeq ($(architecture), powerpc)
	[ -f "$(kernelchrp)" ] || \
		( echo chrp kernel is not available ; exit 1 )
	[ -f "$(kernelpmac)" ] || \
		( echo pmac kernel is not available ; exit 1 )
	[ -f "$(kernelprep)" ] || \
		( echo prep kernel is not available ; exit 1 )
else
  ifeq ($(architecture), sparc)
	[ -f "$(kernel)" ] || \
		( echo standard kernel is not available ; exit 1 )
	[ -f "$(altkernel)" ] || \
		( echo alternative kernel is not available ; exit 1 )
	[ -f "$(altkernel64)" ] || \
		( echo sun4u kernel is not available ; exit 1 )
else
  ifeq ($(architecture), alpha)
	# alpha is tricky
  else
	echo unsupported architecture: $(architecture); false
       endif
      endif
    endif
  endif
endif

#---------------------------------------------------------------------------
# Don't edit below this line

ifeq ($(architecture), sparc)
silo_pkg:=$(shell $(pathcmd:P=silo_*.deb))
arch_rootdisk_deps:=silo1440k.gz silo1440k-sun4u.gz
arch_rescue_deps:=silo1440k.gz
endif

localpackages:=$(shell find $(incoming)/ -name '*_all.deb' -o -name '*_$(architecture).deb')

localfiles:: updates
ifneq ($(strip $(localpackages)),)
	for f in $(localpackages); do \
		if [ ! -f updates/`basename $$f` ]; then \
			echo copying `basename $$f` to updates/ ; \
			cp $$f updates/ ; \
		fi ; \
	done
endif

# dependency for the files that have to be copied
updates::
	mkdir -p updates

base_archive=base$(shell echo $(debianversion) | sed -e 's/\./_/').tgz

build::	localfiles
	$(MAKE) utils
	find . -name \*~ | xargs rm -f
ifeq ($(architecture), i386)
	$(MAKE) resc1440.bin drv1440.bin resc1440-safe.bin
	$(MAKE) resc1200.bin drv1200.bin 
# APH DISABLE TECRA
#	$(MAKE) resc1440tecra.bin drv1440tecra.bin resc1440tecra-safe.bin
	$(MAKE) lowmem.bin
else 
  ifeq ($(architecture), m68k)
	$(MAKE) resc720atari.bin drv720atari.bin 
	$(MAKE) resc1440atari.bin drv1440atari.bin lowmematari.bin
	$(MAKE) resc1440amiga.bin drv1440amiga.bin
	$(MAKE) resc1440mac.bin drv1440mac.bin
	$(MAKE) resc1440bvme6000.bin drv1440bvme6000.bin
	$(MAKE) resc1440mvme162.bin drv1440mvme162.bin
	$(MAKE) resc1440mvme167.bin drv1440mvme167.bin
else 
  ifeq ($(architecture), powerpc)
#	$(MAKE) resc1440apus.bin drv1440apus.bin
	$(MAKE) resc1440chrp.bin drv1440chrp.bin
#	$(MAKE) resc1440mbx.bin drv1440mbx.bin
	$(MAKE) resc1440pmac.bin drv1440pmac.bin
	$(MAKE) resc1440prep.bin drv1440prep.bin
	$(MAKE) tftpboot.img tftpboot-powerpc.img root.tar.gz
else
  ifeq ($(architecture), sparc)
	$(MAKE) resc1440.bin drv1440.bin \
			resc1440-$(altkver).bin drv1440-$(altkver).bin \
			resc1440-$(altkver)-sun4u.bin drv1440-$(altkver)-sun4u.bin \
			tftpboot.img tftpboot-$(altkver).img \
			root.tar.gz
else
  ifeq ($(architecture), alpha)
	$(MAKE) $(alpha_rescue_targets) $(alpha_drivers_targets) root1440.bin
  else
	echo unsupported architecture: $(architecture); false
       endif
      endif
    endif
  endif
endif
	$(MAKE) $(base_archive)

utils:
	$(MAKE) -C utilities KVER=$(kver) LINGUA=$(LINGUA)

define hack-dinstall-msgs
  [ -f utilities/dinstall/messages/lang_$(LINGUA).h ] ||		\
	ln -s lang_C.h utilities/dinstall/messages/lang_$(LINGUA).h
endef

define unhack-dinstall-msgs
  [ ! -L utilities/dinstall/messages/lang_$(LINGUA).h ] ||		\
	rm -f utilities/dinstall/messages/lang_$(LINGUA).h
endef

docs:
	$(hack-dinstall-msgs)
	$(MAKE) -C documentation KVER=$(kver) ALTKVER=$(altkver)	\
		RELEASE=$(debianversion)				\
		util-linux=$(shell $(pathcmd:P=util-linux_*.deb))	\
		amiga-fdisk=$(shell $(pathcmd:P=amiga-fdisk_*.deb))	\
		atari-fdisk=$(shell $(pathcmd:P=atari-fdisk_*.deb))	\
		mac-fdisk=$(shell $(pathcmd:P=mac-fdisk_*.deb))		\
		pmac-fdisk-cross=$(shell $(pathcmd:P=pmac-fdisk-cross_*.deb))
	$(unhack-dinstall-msgs)

# documentation for all architectures
all-arch-docs:
	[ -d documentation/arch ] || mkdir documentation/arch
	set -e								;\
	for arch in `grep ARCH documentation/defaults.ent | cut -d' ' -f 3`; do	\
		$(MAKE) architecture=$$arch all-arch-docs-internal	;\
	done

all-arch-docs-internal:
	$(hack-dinstall-msgs)
	$(MAKE) -C documentation KVER=$(kver) ALTKVER=$(altkver)	\
		RELEASE=$(debianversion)				\
		util-linux=$(shell $(pathcmd:P=util-linux_*.deb))	\
		amiga-fdisk=$(shell $(pathcmd:P=amiga-fdisk_*.deb))	\
		atari-fdisk=$(shell $(pathcmd:P=atari-fdisk_*.deb))	\
		mac-fdisk=$(shell $(pathcmd:P=mac-fdisk_*.deb))		\
		pmac-fdisk-cross=$(shell $(pathcmd:P=pmac-fdisk-cross_*.deb)) \
		all-arches
	$(unhack-dinstall-msgs)

# documentation for all architectures and languages
all-lang-arch-docs:
	$(MAKE) LINGUA=C all-arch-docs
	@# note that you have to manually add languages which don't have 
	@# dinstall translations; note that sk is skipped due to lack of
	@# debiandoc-sgml support
	set -e								;\
	for file in utilities/dinstall/messages/lang_*.h fi ja; do	\
	  lang=`basename $$file | sed -e 's/lang_//; s/\.h//;'`		;\
	  if [ -s utilities/dinstall/messages/lang_$$lang.h -a		\
	       -e "documentation/install.$$lang.sgml" -a		\
	       -e "documentation/release-notes.$$lang.sgml" -a		\
	       -e "documentation/dselect-beginner.$$lang.sgml" ]; then	\
	    if [ $$lang != sk ]; then 					\
	      echo "** making documentation for language $$lang"	;\
	      rm -f documentation/messages.ent				;\
	      $(MAKE) LINGUA=$$lang all-arch-docs			;\
	      echo							;\
	    else							\
	      echo "** skipping documentation for language $$lang"	;\
	    fi								\
	  fi								\
	done

release:: build
	mkdir -p release
	$(MAKE) -C documentation DESTDIR=$(shell pwd)/release install
	cp base-contents release/basecont.txt
	cp *.bin base*.tgz release/
ifeq ($(architecture), i386)
	cp documentation/README-tecra documentation/README-safe release/
	if [ -f linuxtecra ]; then cp linuxtecra release/ltecra ; fi
	# DOS tools provided for i386 only (if other arches need, eg.
	# rawrite, take them from i386 boot-disks directory)
	recode latin1:ibmpc <scripts/dos/install.bat >release/install.bat
	cd release && unzip $(tools_dir)/rawrite2.zip rawrite2.exe rawrite2.txt
	cd release && unzip -p $(tools_dir)/lodlin16.zip \

=== documentation/Makefile ===
# Makefile for documentation
# 
# Generally called from the top level Makefile with 'make docs'
#
# If you want to run this manually, you'll have to set your variable
# properly:  'make KVER=2.0.35 LINGUA=C RELEASE=2.1 DEB_VERSION=test	\
#		DATE="`date`" architecture=i386'

# fdisk documentation to include (varies per platform)
FDISK_DOCS	:= $(shell grep fdisk 					\
			../scripts/rootdisk/SMALL_BASE_LIST_$(architecture)\
			| sed -e 's/^.*\/\(.*\)/\1.txt/')

# set extension of source/dest files based on LINGUA
ifeq ($(LINGUA),C)
SRCEXT		:=
DESTEXT		:= .en
else
SRCEXT		:= .$(LINGUA)
DESTEXT		:= .$(LINGUA)
endif

# programs for creating output
DEBIANDOC2HTML	:= debiandoc2html -l $(LINGUA) -c -d /usr/lib/sgml/declaration/debiandoc.decl
DEBIANDOC2PS	:= debiandoc2ps -l $(LINGUA) -d /usr/lib/sgml/declaration/debiandoc.decl
DEBIANDOC2TEXT	:= debiandoc2text -l $(LINGUA) -d /usr/lib/sgml/declaration/debiandoc.decl
DEBIANDOC2LATEX	:= debiandoc2latex2e -l $(LINGUA) -d /usr/lib/sgml/declaration/debiandoc.decl

# maximum times we're willing to run TeX to get cross-references right
MAX_TEX_RECURSION	:= 5

# documents to build
TARGETDOCS	:= install$(DESTEXT).txt install$(SRCEXT).html/install$(DESTEXT).html 	\
		   dselect-beginner$(SRCEXT).html/dselect-beginner$(DESTEXT).html	\
		   dselect-beginner$(DESTEXT).txt $(FDISK_DOCS)

# you might want to remove this if it is failing for you
TARGETDOCS	+= install$(DESTEXT).pdf


# just an unreasonable default
DESTDIR		:= /tmp

install_file	:= install -m 644 -p
makedir		:= mkdir -m 0755

# needed for dynamic.ent target
DATEFORM_hr	:= %-d. %-m. %Y.
ifeq ($(DATEFORM_$(LINGUA)),)
DATEFORM_$(LINGUA) := %d %B, %Y
endif

DEB_VERSION	:= $(shell cd .. && LC_ALL=C dpkg-parsechangelog |	\
			grep '^Version: ' | sed 's/^Version: *//')
DATE		:= $(shell cd .. && date --date="`dpkg-parsechangelog |	\
			grep '^Date: ' | sed 's/^Date: *//'`" \
			'+$(strip $(DATEFORM_$(LINGUA)))')

DINSTALL_DIR	:= ../utilities/dinstall

# derived entity files
DERIVED_ENTS	:= messages.ent dynamic.ent

.PHONY:	default
default:	supplemental_makefile $(TARGETDOCS)

.PHONY:	test
test:
	@echo TARGETDOCS: $(TARGETDOCS)
	@echo util-linux is at: $(util-linux)

.PHONY:	supplemental_makefile
supplemental_makefile:
	[ ! -f $(LINGUA)/Makefile ] || $(MAKE) -C $(LINGUA)

.PHONY:	all-arches
all-arches:	default							\
		release-notes$(SRCEXT).html/index.html release-notes$(DESTEXT).txt\
		all-messages.ent
	[ -d arch/$(architecture) ] || mkdir -p arch/$(architecture)
	$(install_file) install$(SRCEXT).html/*				\
		install$(DESTEXT).txt dselect-beginner$(DESTEXT).txt	\
		dselect-beginner$(SRCEXT).html/* arch/$(architecture)/
	[ ! -f install$(DESTEXT).pdf ] ||				\
	    $(install_file) install$(DESTEXT).pdf arch/$(architecture)/
	[ -d arch/$(architecture)/release-notes ] ||			\
		mkdir -p arch/$(architecture)/release-notes
	$(install_file) release-notes$(SRCEXT).html/*			\
	    arch/$(architecture)/release-notes/
	mv release-notes$(DESTEXT).txt					\
	    arch/$(architecture)/release-notes/index$(DESTEXT).txt
	@# setting our nice content-negotiation symlinks
	set -e								;\
	for file in `find arch/$(architecture) -name '*.en.*'`; do	\
	    ln -sf `echo $$file | sed -e 's/^.*\///'` 			\
		   `echo $$file | sed -e 's/\.en//'`			;\
	done
	[ -d arch/source ] || mkdir -p arch/source
	$(install_file) dynamic.ent arch/source/dynamic.ent.$(architecture)
	@# repetitive
	$(install_file) *.sgml *.ent ChangeLog README-authors arch/source/
	tar c --exclude CVS `find . -maxdepth 1 -type d -name '??'`	\
	    | tar x -C arch/source/

.PHONY:	mirror-to-master
mirror-to-master:
	[ -d arch ]
	rsync -rltDgvz --rsh ssh --exclude 'powerpc' arch/		\
	  master.debian.org:/org/www.debian.org/debian.org/releases/slink/

install$(SRCEXT).html/install$(DESTEXT).html:	install$(SRCEXT).sgml	\
					$(DERIVED_ENTS) defaults.ent
	$(DEBIANDOC2HTML) -t install $<

install$(DESTEXT).txt:	install$(SRCEXT).sgml defaults.ent $(DERIVED_ENTS)
	$(DEBIANDOC2TEXT) -O $< > $@

install$(DESTEXT).ps:	install$(SRCEXT).sgml defaults.ent $(DERIVED_ENTS)
	$(DEBIANDOC2PS) -O $< > $@

install$(DESTEXT).tex:	install$(SRCEXT).sgml defaults.ent $(DERIVED_ENTS)
	$(DEBIANDOC2LATEX) -O $< > $@

%.pdf:	%.tex
#	 note that I have seen bi-stable .aux files, thus we check two levels deep
	-cp -pf prior.aux pprior.aux
	-cp -pf $(shell basename $< .tex).aux prior.aux
#	 fail if we don't have pdflatex correctly installed
	kpsewhich pdflatex.fmt > /dev/null
#	 due to a bug in debiandoc2latex2e output, this might fail
	-pdflatex '\nonstopmode\input{$<}'
	set -e								;\
	if ! cmp $(shell basename $< .tex).aux prior.aux &&		\
	   ! cmp $(shell basename $< .tex).aux pprior.aux &&		\
	   expr $(MAKELEVEL) '<' $(MAX_TEX_RECURSION); then		\
		rm -f $@						;\
		$(MAKE) $@						;\
	fi
	rm -f prior.aux pprior.aux

dselect-beginner$(SRCEXT).html/dselect-beginner$(DESTEXT).html:		\
		dselect-beginner$(SRCEXT).sgml defaults.ent $(DERIVED_ENTS)
	$(DEBIANDOC2HTML) -t dselect-beginner $<

dselect-beginner$(DESTEXT).txt:	dselect-beginner$(SRCEXT).sgml defaults.ent	\
			$(DERIVED_ENTS)
	$(DEBIANDOC2TEXT) -O $< > $@

dselect-beginner$(DESTEXT).ps:	dselect-beginner$(SRCEXT).sgml defaults.ent	\
			$(DERIVED_ENTS)
	$(DEBIANDOC2PS) $<

dselect-beginner$(DESTEXT).tex:	dselect-beginner$(SRCEXT).sgml defaults.ent	\
			$(DERIVED_ENTS)
	$(DEBIANDOC2LATEX) -O $< > $@

release-notes$(SRCEXT).html/index.html:	release-notes$(SRCEXT).sgml 		\
			defaults.ent $(DERIVED_ENTS)
	$(DEBIANDOC2HTML) $<

release-notes$(DESTEXT).txt:	release-notes$(SRCEXT).sgml defaults.ent	\
			$(DERIVED_ENTS)
	$(DEBIANDOC2TEXT) -O $< > $@

cfdisk.txt:
	-[ -f "$(util-linux)" ] && (					\
	  dpkg --fsys-tarfile $(util-linux) |				\
		tar -xOf - '*/man8/cfdisk.8.gz' | zcat > tmp		;\
	  man -l tmp | col -b > $@					;\
	  rm -f tmp							;\
	)
	[ -f $@ ] || echo '** man page not found ** ' > $@

fdisk.txt:
	-[ -f "$(util-linux)" ] && (					\
	  dpkg --fsys-tarfile $(util-linux) |				\
		tar -xOf - '*/man8/fdisk.8.gz' | zcat > tmp		;\
	  man -l tmp | col -b > $@					;\
	  rm -f tmp							;\
	)
	[ -f $@ ] || echo '** man page not found ** ' > $@

atari-fdisk.txt:
	-[ -f "$(atari-fdisk)" ] && (					\
	  dpkg --fsys-tarfile $(atari-fdisk) |				\
		tar -xOf - '*/man8/atari-fdisk.8.gz' | zcat > tmp	;\
	  man -l tmp | col -b > $@					;\
	  rm -f tmp							;\
	)
	[ -f $@ ] || echo '** man page not found ** ' > $@

amiga-fdisk.txt:
	-[ -f "$(amiga-fdisk)" ] && (					\
	  dpkg --fsys-tarfile $(amiga-fdisk) |				\
		tar -xOf - '*/man8/amiga-fdisk.8.gz' | zcat > tmp	;\
	  man -l tmp | col -b > $@					;\
	  rm -f tmp							;\
	)
	[ -f $@ ] || echo '** man page not found ** ' > $@

mac-fdisk.txt:
	-[ -f "$(mac-fdisk)" ] && (					\
	  dpkg --fsys-tarfile $(mac-fdisk) |				\
		tar -xOf - '*/man8/pdisk.8.gz'  | zcat > tmp	;\
	  man -l tmp | col -b > $@					;\
	  rm -f tmp							;\
	)
	[ -f $@ ] || echo '** man page not found ** ' > $@

pmac-fdisk.txt:
	-[ -f "$(pmac-fdisk-cross)" ] && (				\
	  dpkg --fsys-tarfile $(pmac-fdisk-cross) |			\
		tar -xOf - '*/man8/pdisk.8.gz'  | zcat > tmp		;\
	  man -l tmp | col -b > $@					;\
	  rm -f tmp							;\
	)
	[ -f $@ ] || echo '** man page not found ** ' > $@

.PHONY:	install
install:	default
	$(install_file) $(TARGETDOCS)					\
		$(wildcard dselect-beginner$(SRCEXT).html/*		\
		install$(SRCEXT).html/*) $(DESTDIR)

.PHONY:	clean
clean:
	rm -rf arch
	rm -f $(DERIVED_ENTS)
	rm -f $(TARGETDOCS)
	rm -rf install*.html dselect-beginner*.html release-notes*.html
	rm -f *fdisk*.txt release-notes*.txt dselect-beginner*.txt install*.txt
	rm -f messages*.ent
	rm -f *~ *.log *.aux *.bak *.out *.sasp *.toc *.tex *.dvi *.pdf *.ps
	set -e ; for dir in `find . -type d -mindepth 1 -maxdepth 1`; do\
	    [ ! -f $$dir/Makefile ] || $(MAKE) -C "$$dir" $@		;\
	done

.PHONY:	distclean
distclean: clean

.PHONY:	validate
validate:	$(DERIVED_ENTS)
	set -e; for i in *.sgml; do					\
	  nsgmls -wall -s -E20 $$i.sgml					;\
	done

.PHONY: dynamic.ent
dynamic.ent: ../debian/changelog Makefile
#	entities which are dynamically defined by the settings of this build
#	run, generally set in the top-level makefile
ifeq ($(architecture),)
	@echo "error: invoke '$(MAKE) docs' from top level Makefile"
	exit 1
endif
#	 to avoid false dependancy rebuilds, we try to be a bit tricky,
#	 keeping the previous copy around and moving it back if there's no difference
	[ ! -f $@ ] || mv -f $@ $@.old
	: > $@			# clear the file
	echo "<!entity docversion    \"$(DEB_VERSION)\">" >> $@
	echo "<!entity docdate       \"$(DATE)\">" >> $@
	echo "<!entity language      \"$(LINGUA)\">" >> $@
	echo "<!entity release       \"$(RELEASE)\">" >> $@
	echo "<!entity kernelversion \"$(KVER)\">" >> $@
	echo "<!entity altkernelversion \"$(ALTKVER)\">" >> $@
	echo "<!entity architecture  \"$(architecture)\">" >> $@
	echo "<!entity % $(architecture) \"INCLUDE\">" >> $@
	echo "<!entity % lang-$(LINGUA) \"INCLUDE\">" >> $@
	set -e; for i in $(FDISK_DOCS); do			\
		echo "<!entity % $$i \"INCLUDE\">" >> $@	;\
	done
#	 now test if the new version is in fact the same
	set -e; if cmp $@ $@.old; then				\
		mv -f $@.old $@					;\
		echo dynamic.ent has no changes			;\
	else							\
		rm -f $@.old					;\
	fi

# all messages.ent files
all-messages.ent:
	set -e							;\
	for file in $(DINSTALL_DIR)/messages/lang_*.h; do	\
	  lang=`basename $$file | sed -e 's/lang_//; s/\.h//;'`	;\
	  ./cpp2sgml $$file > messages_$$lang.ent		;\
	done

messages.ent:	$(DINSTALL_DIR)/messages/lang_$(LINGUA).h cpp2sgml
#	entities which are dynamically defined from the dinstall messages
	./cpp2sgml $(DINSTALL_DIR)/messages/lang_$(LINGUA).h > $@

# in case LINGUA isn't set, give a decent err message
$(DINSTALL_DIR)/messages/lang_.h:
	@echo LINGUA is not set -- see the documentation at the top of this Makefile
	exit 1

install$(SRCEXT).sgml: defaults.ent $(DERIVED_ENTS)

=== utilities/Makefile ===
KVER=
CC	:= gcc
CFLAGS	:= -O2 -fomit-frame-pointer
LDFLAGS	:= -s
arch	:= $(shell dpkg --print-architecture)

#ifndef LINGUA
	LINGUA=C
	export LINGUA
#endif

SPLIT_OBJECTS= floppy_split.o

all: floppy_split
	$(MAKE) -C libfdisk "CFLAGS=-O2 -DINCLUDE_DINSTALL" libfdisk.a
	$(MAKE) -C dinstall KVER=$(KVER) INCLUDE_DINSTALL=1 build-objects
	$(MAKE) -C busybox INCLUDE_DINSTALL=1
	$(MAKE) -C writemaps loadkeys
ifneq ($(arch), m68k)
	$(MAKE) -C lowmemrd
endif

clean:
	rm -f *.o *.bak
	$(MAKE) -C libfdisk clean
	$(MAKE) -C busybox clean
	$(MAKE) -C dinstall clean
	$(MAKE) -C writemaps clean
	$(MAKE) -C lowmemrd clean

distclean: clean
	rm -f floppy_split *.o *.bak
	$(MAKE) -C busybox distclean
	$(MAKE) -C libfdisk distclean
	$(MAKE) -C dinstall distclean
	$(MAKE) -C lowmemrd distclean

floppy_split: $(SPLIT_OBJECTS)
	$(CC) $(LDFLAGS) -o $@ $(SPLIT_OBJECTS)

$(SPLIT_OBJECTS): floppy_split.h

=== utilities/dinstall/Makefile ===
LIBS = -lnewt -lslang -lc #-lefence

#ifndef LINGUA
	LINGUA=C
#endif
#ifndef KVER
	KVER=2.0.35
#endif

ARCH=$(shell dpkg --print-architecture)
CFLAGS = -O2 -D_GNU_SOURCE 
CFLAGS += -DARCH=$(ARCH) -DARCHNAME='"$(ARCH)"' 
CFLAGS += -DKVER='"$(KVER)"' 
CFLAGS += -DLINGUA='"$(LINGUA)"' -DINCLINGUA='"messages/lang_$(LINGUA).h"'
ifdef FONT
 CFLAGS += -DFONT='"$(FONT)"'
endif
CFLAGS += -Wall -g
# CFLAGS += -DLOG 
# CFLAGS += -DTEST
ifdef INCLUDE_DINSTALL
 CFLAGS += -DINCLUDE_DINSTALL
endif

PROG = dbootstrap

BBOXOBJS = ../busybox/descend.o ../busybox/postprocess.o \
  ../busybox/fdflush.o ../busybox/losetup.o ../busybox/mount.o \
  ../busybox/mkdir.o ../busybox/utility.o ../busybox/findmount.o \
  ../busybox/umount.o ../busybox/swapon.o ../busybox/swapoff.o \
  ../busybox/block_device.o
LIBFDISK = ../libfdisk/libfdisk.a

OBJECTS = $(patsubst %.c,%.o,$(wildcard *.c))

SOURCES = $(subst .o,.c,$(OBJECTS)) dinstall.h

TEST = bootconfig_test boxes_test choose_medium_test color_or_monochrome_test \
	floppy_merge_test interactive_shell_test kbdconfig_test main_menu_test \
	netconfig_test pcmcia_test reboot_system_test release_notes_test \
	tzconfig_test select_not_mounted_test

all:    depend $(PROG)

build-objects: $(OBJECTS)

$(PROG):	build-objects $(BBOXOBJS) $(LIBFDISK)
	$(CC) $(CFLAGS) -o $(PROG) $(OBJECTS) $(BBOXOBJS) $(LIBFDISK) $(LIBS)

$(LIBFDISK): force
	$(MAKE) -C ../libfdisk libfdisk.a

depend: $(SOURCES)
	$(CPP) $(CFLAGS) -M $(SOURCES) > .depend

clean: 
	rm -rf $(OBJECTS) *_test 

distclean: clean
	rm -f $(PROG) .depend

force:

test: $(TEST)

boxes_test: boxes.c
	$(CC) $(CFLAGS) -o ./$@ -D_BOXTESTING_ -g $^ $(LIBS)

color_or_monochrome_test: color_or_monochrome.c
	$(CC) $(CFLAGS) -o ./$@ -D_TESTING_ -g $^ $(LIBS)

floppy_merge_test: floppy_merge.c boxes.c
	$(CC) $(CFLAGS) -o ./$@ -D_TESTING_ -g $^ $(LIBS)

interactive_shell_test: interactive_shell.c boxes.c
	$(CC) $(CFLAGS) -o ./$@ -D_TESTING_ -g $^ $(LIBS)

kbdconfig_test: kbdconfig.c boxes.c
	$(CC) $(CFLAGS) -o ./$@ -D_TESTING_ -g $^ $(LIBS)

main_menu_test: main_menu.c boxes.c
	$(CC) $(CFLAGS) -o ./$@ -D_TESTING_ -g $^ $(LIBS)

netconfig_test: netconfig.c boxes.c nfsroot.c \
	../busybox/descend.c ../busybox/cp.c ../busybox/utility.c \
	../busybox/postprocess.c
	$(CC) $(CFLAGS) -o ./$@ -D_TESTING_ -g $^ $(LIBS)

reboot_system_test: reboot_system.c boxes.c
	$(CC) $(CFLAGS) -o ./$@ -D_TESTING_ -g $^ $(LIBS)

release_notes_test: release_notes.c boxes.c
	$(CC) $(CFLAGS) -o ./$@ -D_TESTING_ -g $^ $(LIBS)

tzconfig_test: tzconfig.c boxes.c
	$(CC) $(CFLAGS) -o ./$@ -D_TESTING_ -g $^ $(LIBS)

pcmcia_test: pcmcia.c boxes.c ../busybox/mkdir.c ../busybox/utility.c
	$(CC) $(CFLAGS) -o ./$@ -D_TESTING_ -g $^ $(LIBS)

bootconfig_test: bootconfig.c boxes.c select_not_mounted.c lists.c \
	../busybox/umount.c ../busybox/mount.c ../busybox/utility.c \
	../busybox/fdflush.c ../busybox/findmount.c
	$(CC) $(CFLAGS) -o ./$@ -D_TESTING_ -g $^ $(LIBS)

choose_medium_test: choose_medium.c boxes.c select_not_mounted.c lists.c \
	no_match.c ../busybox/descend.c ../busybox/postprocess.c \
	../busybox/umount.c ../busybox/mount.c ../busybox/utility.c \
	../busybox/findmount.c $(LIBFDISK)
	$(CC) $(CFLAGS) -o ./$@ -D_CTESTING_ -g $^ $(LIBS)

select_not_mounted_test: boxes.c select_not_mounted.c lists.c \
	no_match.c ../busybox/descend.c ../busybox/postprocess.c \
	../busybox/umount.c ../busybox/mount.c ../busybox/utility.c \
	../busybox/findmount.c $(LIBFDISK)
	$(CC) $(CFLAGS) -o ./$@ -D_STESTING_ -g $^ $(LIBS)

partition_config_test: partition_config.c boxes.c select_not_mounted.c lists.c choose_medium.c no_match.c \
	../busybox/mount.c ../busybox/umount.c ../busybox/mkdir.c \
	../busybox/swapoff.c ../busybox/swapon.c ../busybox/findmount.c \
	../busybox/utility.c ../busybox/block_device.c ../busybox/descend.c \
	../busybox/postprocess.c $(LIBFDISK)
	$(CC) $(CFLAGS) -o ./$@ -D_TESTING_ -g $^ $(LIBS)

# Not ready yet...
# select_not_mounted 
# is_root_a_floppy lists main no_match partition_config

ifeq (.depend,$(wildcard .depend))
include .depend
endif

=== utilities/libfdisk/Makefile ===
LIBS = -lc #-lefence

CFLAGS = -Wall -O2 -fomit-frame-pointer
# CFLAGS = -Wall -O2 -DARCH="i386"
# CFLAGS = -Wall -O2 -DARCH="m68k"
# CFLAGS += -g -DDEBUG

# PROGS = testing
PROGS=

OBJS = fdisk.o partbl_msdos.o partbl_osf.o partbl_sun.o partbl_amiga.o \
       partbl_atari.o partbl_mac.o

SOURCES = $(subst .o,.c,$(OBJS)) fdisk.h byteorder.h config.h testing.c

all:    depend $(PROGS)

libfdisk.a: $(OBJS)
	$(AR) rcs $@ $(OBJS)

testing: testing.o libfdisk.a
	$(CC) $(LDFLAGS) -o testing $^ $(LIBS)

depend: $(SOURCES)
	$(CPP) $(CFLAGS) -M $(SOURCES) > .depend

clean: 
	rm -f $(OBJS) libfdisk.a testing.o

distclean: clean
	rm -f $(PROGS) .depend

ifeq (.depend,$(wildcard .depend))
include .depend
endif

=== utilities/lowmemrd/Makefile ===
OBJECTS = linuxrc.o mkswap.o fdisk.o llseek.o
LIBS = ../libfdisk/libfdisk.a /usr/lib/libz.a

DEBUG=
STRIP=-s
all: linuxrc

linuxrc: $(OBJECTS) $(LIBS)
	gcc $(DEBUG) $(STRIP) -static -Wall -o linuxrc $(OBJECTS) $(LIBS)

%.o: %.c
	$(CC) -O2 $(DEBUG) -Wall -c $<

clean:
	rm -f *.o 

distclean: clean
	rm -f linuxrc zcat

=== utilities/writemaps/Makefile ===
ifndef DATADIR
DATADIR = /usr/share/keymaps
endif

ifndef BINDIR
BINDIR = /usr/bin
endif

PROGS   = loadkeys 

WARN	= -Wall
DEFS	= -DDATADIR=\"$(DATADIR)\"
CFLAGS  = -O2
LDFLAGS = -s

CC	= gcc
YACC	= bison -y
LEX	= flex -8

.c.o:
	$(CC) -c $(WARN) $(CFLAGS) $(DEFS) $<

all: $(PROGS)

# loadkeys.o: separate rule since the flex output does not permit -Wall
loadkeys.o:	loadkeys.c analyze.c
	$(CC) -c $(CFLAGS) $(DEFS) $<


clean:
	rm -f core *.o analyze.c loadkeys.c loadkeys

$(PROGS): %: %.o

loadkeys: ksyms.o

ksyms.o: cyrillic.syms.h ethiopic.syms.h

loadkeys.o: paths.h

loadkeys: findfile.o

loadkeys: getfd.o

=== scripts/basedisks/master2files/Makefile ===
# If you have several packages files:
# PACKAGES=/somewhere/Packages-main,/somewhere/Packages-contrib,/somewhere/Packages-nonfree
PACKAGES=/somewhere/Packages
TARBALL=/var/tmp/lists.tar
DIRECTORIES=master2files new_root_home/profiles new_root_home/tasks
TARGETS=../new_root_home/profiles ../new_root_home/tasks
FILESPRODUCED=../new_root_home/profiles/* ../new_root_home/tasks/*

architecture=$(shell dpkg --print-architecture)

all: build

build: master
	slice master
	./master2files ${architecture} ${PACKAGES}
	touch build

tarball:
	(cd ..; \
	tar cvf ${TARBALL} ${DIRECTORIES}; \
	gzip -9 -f -v ${TARBALL})

clean:
	-rm -f master.*
	-rm -f build
	-rm -f ${FILESPRODUCED}
	-rmdir ${TARGETS}

=== debian/changelog ===
boot-floppies (2.1.12) stable; urgency=low

  * update for 2.1r4
  * i386: use kernel 2.0.38; disable tecra flavor, no longer needed
  * tasks/profiles: add samba-doc and samba-common pkgs; lsof-2.0.36 and
    lpr should probably be added but I didn't

 -- Adam Di Carlo <aph@debian.org>  Thu,  9 Dec 1999 14:06:56 -0800

boot-floppies (2.1.11) unstable; urgency=low

  * Changes made by Martin Schulze <joey@debian.org> to provide proper
    German disk images.  Details follow:
    - Added support for a creator != maintainer, main Makefile and
      rootdisk.sh
    - Added detection for modules in main makefile since both minix
      support and loopback support is sufficient when provided as modules
      and kerneld/kmod
    - Extracted MSG_BOOT_MESSAGE_TEXT from all lang_<lang>.h files into a
      boot_message file.  This file will be converted by rootdisk.sh to
      use the proper charset which was required since it is displayed
      before Linux is loaded and thus the IBMPC charset is used on intel
      boxes.
    - Added support for boot_message to rootdisk.sh.  The routine for
      recoding the file was stolen from rescue.sh, well, the skeleton and
      ideas were.
    - Heavily updated de.po for root_profile, changed formattings, changed
      from "Du" to "Sie" which is more kind.
    - .bash_profile: Unset LANG before dselect is called to avoid Perl
      complain about locale.  This is a workaround and needs a proper fix
      for Perl!!!
    - Updated boot messages for SYSLINUX, changed formattings, changed
      from "Du" to "Sie" which is more kind.
    - Updated release_notes, changed formattings, changed from "Du" to
      "Sie".
    - kbdconfig.c: Turned all keyboard descriptions into defines in order
      to fit with our scheme of i18n.
    - Extended lang_C.h and lang_de.h to contain these descriptions.
    - partition_config.c: Added support for LINGUA/LANG when issuing
      `cfdisk'.  Same goes for `mkfs'.  Also added proper _test target so
      we can test this dialog locally as well.
    - Added new addresses and notices to README-Translators.
  * Updated and corrected English, German, Japanese and Russian 
    documentation (closes: Bug#38442); added Portuguese, Spanish, South
    Korean; change /etc/password to /etc/passwd (closes: Bug#42124); some
    TFTP clarifications (closes: Bug#43397)
  * skip configuring the keyboard on serial console installation.
  * fixed a problem with non-bootable floppy images on ultrasparc (new
    silo1440k-sun4u image required to build).  Compiled with silo 0.8.6-1 to
    fix a bug in booting SunOS on ultrasparc.

 -- Adam Di Carlo <aph@debian.org>  Sat, 28 Aug 1999 14:51:41 -0400

boot-floppies (2.1.10) stable; urgency=low

  * forked slink version (potato work now proceeding in the 2.2 tree)
  * rootdisk.sh: provide hde hdf hdg hdh devices on i386 (closes Bug#34934);
    provide eda and edb devices for ESDI drives (closes Bug#33938)
  * busybox/ls.c: include overflow protection patch from Avery Pennarun
    (closes Bug#33781)
  * added PS/2 keymaps for sparc (closes Bug#35649); fix problem in
    kbd support for PPC
  * fixes for /dev/console support in 2.2 kernel.  Note that 2.2 is still
    rather unofficial, although required for sun4u
  * busybox: mkswap handles v1 swap partition layouts (closes Bug#34072)
  * debian/control: version the libc6-pic dependancy (closes Bug#31797)
  * lowmem: update documentation, debian.txt now correctly states that
    this floppy is for RAM situations between 4MB and 6MB (closes Bug#33145)
  * documentation:
    new build to pick up documentation changes in the 2.1.9.x series
      (closes Bug#34691)
    correction in PDF makefiles; this was leading to bad TOCs
    low memory installation and lowmemrd.bin now better documented
      (closes Bug#26626); when root.bin is needed better documented
    boot troubleshooting: add more hints, for hlt problems and lowmem on
      i386, bad NVRAM on sparc
    require debiandoc-sgml >= 1.1.18, for content negotiated output and
      non-English documentation
    languages now building documentation for: Croatian, Finnish, Japanese,
      French, Czech (not all these languages are fully translated)

 -- Adam Di Carlo <aph@debian.org>  Sun, 18 Apr 1999 14:46:09 -0400

boot-floppies (2.1.9.2) unstable; urgency=low

  * note odd version; not official release
  * many changes for powerpc build; newt dependancy changes to be platform
    specific since powerpc needs the potato version
  * VME: Debian.txt fix, instal-vme added to installed files; Mac file
    fixes; add Minix libfdisk for Amiga
  * release-notes: some factual fixes
  * documentation: VME documentation added; Japanese, Finnish, and
    Croatian translations added; makefiles adapted to deal with
    multi-lingual documentation files; install.sgml broken up into smaller
    SGML files since the size of that file was getting unmanagable; build
    system modified to enable the build of multi-lingua docs more fully

 -- Adam Di Carlo <aph@debian.org>  Fri, 19 Mar 1999 01:46:14 -0500

boot-floppies (2.1.9.1) unstable; urgency=low

  * note odd version; not official release
  * debian/control: add libwww-perl, needed to build documentation
  * documentation: minor updates for architectures and grammar, spelling;
    "Partitioning From SunOS": new section for sparc; sparc notes about
    Sun disk labels in the dbootstrap parititoning section; add nfsroot
    and serial console support for m68k; talk about the silo a tiny bit;
    change official title of alpha to 'Alpha'

 -- Adam Di Carlo <aph@debian.org>  Sun,  7 Mar 1999 12:21:01 -0500

boot-floppies (2.1.9) unstable frozen; urgency=high

  * Maintainer release.
  * Fixed typos in es.po. Closes #33810
  * Included fixed dpkg.
  * Updated italian, spanish and espaeranto translations.

 -- Enrique Zanardi <ezanard@debian.org>  Mon,  3 Mar 1999 14:14:44 +0000

boot-floppies (2.1.8.1) unstable frozen; urgency=low



=== debian/control ===
Source: boot-floppies
Section: devel
Priority: optional
Maintainer: Enrique Zanardi <debian-boot@lists.debian.org>
Standards-Version: 2.4.0.0

Package: boot-floppies
Architecture: all
Depends: libc6-pic (>= 2.0.7v-1) | libc6.1-pic, slang1-pic, makedev (>=2.3.1-10), newt0.25, newt0.25-dev, popt, zlib1g, zlib1g-dev, recode, make, gettext, slice, m4, lynx (>= 2.6), debiandoc-sgml (>= 1.1.29), man-db, libpaperg, tetex-bin, tetex-extra, libwww-perl
Suggests: unzip
Description: Scripts to create the Debian installation floppy set.
 This package allows you to create a Debian installation system on floppy
 disk or other media, for bootstrapping Debian onto a new system. Most users
 will simply download the disk images to do this, and this package will
 generally only be used by advanced Debian maintainers.

=== debian/rules ===
#!/usr/bin/make -f
# derived from: Sample debian.rules file - for GNU Hello (1.3).
# Copyright 1994,1995 by Ian Jackson.
# I hereby give you perpetual unlimited permission to copy,
# modify and relicense this file, provided that you do not remove
# my name from the file itself.  (I assert my moral right of
# paternity under the Copyright, Designs and Patents Act 1988.)
# This file may have to be extensively modified

# There used to be `source' and `diff' targets in this file, and many
# packages also had `changes' and `dist' targets.  These functions
# have been taken over by dpkg-source, dpkg-genchanges and
# dpkg-buildpackage in a package-independent way, and so these targets
# are obsolete.

export LANG=C
package	:= boot-floppies
arch	:= $(shell dpkg --print-architecture)
version	:= $(shell dpkg-parsechangelog | sed -n 's/^Version: //p')

build:
	$(checkdir)
	$(MAKE) release
	touch build

clean:
	$(checkdir)
	rm -f build
	-$(MAKE) -i distclean
	rm -rf *~ debian/tmp debian/*~ debian/files*

binary-indep:	checkroot
	$(checkdir)
	rm -rf debian/tmp
	install -d debian/tmp debian/tmp/DEBIAN
	install -d debian/tmp/usr/doc/$(package)
	$(MAKE) install prefix=debian/tmp
	$(MAKE) -C debian/tmp/usr/src/boot-floppies clean
	rm -rf `find debian/tmp/usr/src/boot-floppies -name CVS -type d` 
	cp debian/changelog debian/tmp/usr/doc/$(package)/
	gzip -9f debian/tmp/usr/doc/$(package)/changelog
	cp debian/copyright README debian/tmp/usr/doc/$(package)/.
	dpkg-gencontrol -pboot-floppies > debian/tmp/DEBIAN/control
	chown -R root.root debian/tmp
	chmod -R go=rX debian/tmp
	dpkg --build debian/tmp ..

binary-arch:	checkroot build
	$(checkdir)
	(cd release/ ; for i in * ; do \
		cp -p $$i ../../$$i.$(version)-$(arch) ; \
		dpkg-distaddfile -f../debian/files $$i.$(version)-$(arch) byhand - ; \
	done ) 

define checkdir
	test -f rootdisk.sh -a -f debian/rules
endef

# Below here is fairly generic really

binary:		binary-indep binary-arch

source diff:
	@echo >&2 'source and diff are obsolete - use dpkg-source -b'; false

checkroot:
	$(checkdir)
	test root = "`whoami`"

.PHONY: binary binary-arch binary-indep clean checkroot
